Attribute VB_Name = "ControlMaster"
Option Explicit

Private lDiffs() As Integer
Private tDiffs() As Integer
Private wDiffs() As Integer
Private hDiffs() As Integer
Private controls() As Control
Private lefts() As Boolean
Private rights() As Boolean
Private tops() As Boolean
Private bottoms() As Boolean
Private number As Integer

Public Sub LockControl(theControl As Control, pLockLeft As Boolean, pLockTop As Boolean, pLockRight As Boolean, pLockBottom As Boolean)
    ReDim Preserve lefts(number)
    ReDim Preserve rights(number)
    ReDim Preserve tops(number)
    ReDim Preserve bottoms(number)
    ReDim Preserve controls(number)
    ReDim Preserve wDiffs(number)
    ReDim Preserve hDiffs(number)
    ReDim Preserve lDiffs(number)
    ReDim Preserve tDiffs(number) 'all of the above: making room for another control
    number = number + 1
    
    Set controls(UBound(controls)) = theControl
    wDiffs(UBound(wDiffs)) = theControl.Parent.width - theControl.width
    hDiffs(UBound(hDiffs)) = theControl.Parent.height - theControl.height
    lDiffs(UBound(lDiffs)) = theControl.Parent.width - theControl.left
    tDiffs(UBound(tDiffs)) = theControl.Parent.height - theControl.top
    'explanation of the above:
    ' we have to record the differences between the edges of the controls
    ' and the form they're on, so we can refer to them in the resizing/moving
    ' code. an added benefit of using Parent is that this module can handle
    ' controls that are on separate forms.
    
    'below, we're just setting the properties that tell us what to do
    ' with each control, for use in the Resizing sub.
    If pLockRight Then
        If pLockLeft Then
            lefts(UBound(lefts)) = True
        End If
        rights(UBound(rights)) = True
    End If
    If pLockBottom Then
        If pLockTop Then
            tops(UBound(tops)) = True
        End If
        bottoms(UBound(bottoms)) = True
    End If
End Sub
Public Sub Resizing()
    Dim i As Integer
    
    For i = 0 To UBound(controls) 'loop through all the controls that have been locked
        If rights(i) Then 'if the current control is locked right
            If lefts(i) Then 'if it's also locked left
                LockRightLeft i 'we have to "stretch" it between the two edges
            Else
                LockRight i 'we just move it
            End If
        End If
        If bottoms(i) Then 'if the current control is locked bottom
            If tops(i) Then 'if it's also locked top
                LockTopBottom i 'we have to "stretch" it
            Else
                LockBottom i 'we just move it
            End If
        End If
    Next i
    
    'if it's only locked top or only left, we don't have to do anything!
End Sub
Private Sub LockRight(index As Integer)
    Dim controltocheck As Control
    Set controltocheck = controls(index)
    controltocheck.left = controltocheck.Parent.width - lDiffs(index)
'if it's only locked right, we just need to move it, using the "diff"
' that we calculated earlier in the LockControl sub
End Sub

Private Sub LockRightLeft(index As Integer)
    Dim controltocheck As Control
    Set controltocheck = controls(index)
    If (controltocheck.Parent.width - wDiffs(index)) > 0 Then
        controltocheck.width = controltocheck.Parent.width - wDiffs(index)
    End If
    'if it's locked right and left, we have to stretch it, using the "diff"
' that we calculated earlier in the LockControl sub
End Sub

Private Sub LockTopBottom(index As Integer)
    Dim controltocheck As Control
    Set controltocheck = controls(index)
    If (controltocheck.Parent.height - hDiffs(index)) > 0 Then
        controltocheck.height = controltocheck.Parent.height - hDiffs(index)
    End If
'if it's locked top and bottom, we have to stretch it, using the "diff"
' that we calculated earlier in the LockControl sub
End Sub

Private Sub LockBottom(index As Integer)
    Dim controltocheck As Control
    Set controltocheck = controls(index)
    controltocheck.top = controltocheck.Parent.height - tDiffs(index)
'if it's only locked bottom, we just need to move it, using the "diff"
' that we calculated earlier in the LockControl sub
End Sub
